# datasets.Iris

The Iris flower data set or Fisher's Iris data set is a multivariate data set introduced by the British statistician and biologist Ronald Fisher
in his 1936 paper The use of multiple measurements in taxonomic problems as an example of linear discriminant analysis.
It contains 50 samples with 3 classes of 'Setosa', 'versicolor' and 'virginica'



        
### Usage
            
```javascript
import { Iris } from 'kalimdor/datasets';

(async function() {
  const irisData = new Iris();
  const {
    data,         // returns the iris data (X)
    targets,      // list of target values (y)
    labels,       // list of labels
    targetNames,  // list of short target labels
    description   // dataset description
  } = await irisData.load(); // loads the data internally
})();

```



        
### Methods
            
* [load](#λ-load)








        
# Methods
        
---
                    
### λ load
                    
Load datasets
                    

                
Defined in [datasets/Iris.ts:36](https://github.com/JasonShin/kalimdorjs/blob/master/src/lib/datasets/Iris.ts#L36)
                


                        
**Returns:**
                        
:metal: Promise
| Param | Type | Description |
| ------ | ------ | ------ |
| data | any[][] | Training data
| description | string | Dataset description
| labels | string[] | Real labels
| targetNames | string[] | Short labels
| targets | any[] | Target data


