# linear_model.LinearRegression

Ordinary least squares Linear Regression.



        
### Usage
            
```javascript
import { LinearRegression } from './linear_regression';
const linearRegression = new LinearRegression();
const X = [1, 2, 4, 3, 5];
const y = [1, 3, 3, 2, 5];
linearRegression.fit({ X, y });
console.log(lr.predict([1, 2]));
// [ 1.1999999999999995, 1.9999999999999996 ]
```



        
### Methods
            
* [fit](#λ-fit)
            
* [fromJSON](#λ-fromjson)
            
* [predict](#λ-predict)
            
* [toJSON](#λ-tojson)








        
# Methods
        
---
                    
### λ fit
                    
fit linear model
                    

                
Defined in [linear_model/linear_regression.ts:29](https://github.com/JasonShin/kalimdorjs/blob/master/src/lib/linear_model/linear_regression.ts#L29)
                


                        
**Parameters:**
                        
| Param | Type | Default | Description |
| ------ | ------ | ------ | ------ |
| options.X | number[] | [] | training values
| options.y | number[] | [] | target values

                        
**Returns:**
                        
void
                    
### λ fromJSON
                    
Restore the model from a checkpoint
                    

                
Defined in [linear_model/linear_regression.ts:78](https://github.com/JasonShin/kalimdorjs/blob/master/src/lib/linear_model/linear_regression.ts#L78)
                


                        
**Parameters:**
                        
| Param | Type | Default | Description |
| ------ | ------ | ------ | ------ |
| options.b0 | number | null | Coefficients component: b0
| options.b1 | number | null | Coefficients component: b1

                        
**Returns:**
                        
void
                    
### λ predict
                    
Predict using the linear model
                    

                
Defined in [linear_model/linear_regression.ts:46](https://github.com/JasonShin/kalimdorjs/blob/master/src/lib/linear_model/linear_regression.ts#L46)
                


                        
**Parameters:**
                        
| Param | Type | Default | Description |
| ------ | ------ | ------ | ------ |
| X | number[] | [] | Values to predict.

                        
**Returns:**
                        
number[]
                    
### λ toJSON
                    
Get the model details in JSON format
                    

                
Defined in [linear_model/linear_regression.ts:57](https://github.com/JasonShin/kalimdorjs/blob/master/src/lib/linear_model/linear_regression.ts#L57)
                


                        
**Returns:**
                        
| Param | Type | Description |
| ------ | ------ | ------ |
| b0 | number | Coefficients component: b0
| b1 | number | Coefficients component: b1


