# preprocessing.LabelEncoder

Encode labels with value between 0 and n_classes-1.



        
### Usage
            
```javascript
import { LabelEncoder } from 'kalimdor/preprocessing';

const labelEncoder = new LabelEncoder();
const labelX = ['amsterdam', 'paris', 'tokyo'];
labelEncoder.fit(labelX);
const transformX = ['tokyo', 'tokyo', 'paris'];
const result = labelEncoder.transform(transformX);
// [ 2, 2, 1 ]
```



        
### Methods
            
* [fit](#λ-fit)
            
* [transform](#λ-transform)








        
# Methods
        
---
                    
### λ fit
                    
Fit label encoder
                    

                
Defined in [preprocessing/label.ts:23](https://github.com/JasonShin/kalimdorjs/blob/master/src/lib/preprocessing/label.ts#L23)
                


                        
**Parameters:**
                        
| Param | Type | Default | Description |
| ------ | ------ | ------ | ------ |
| X | any[] | null | Input data in array or matrix

                        
**Returns:**
                        
void
                    
### λ transform
                    
Transform labels to normalized encoding.
                    
Given classes of [&#x27;amsterdam&#x27;, &#x27;paris&#x27;, &#x27;tokyo&#x27;]

It transforms [&quot;tokyo&quot;, &quot;tokyo&quot;, &quot;paris&quot;]

Into [2, 2, 1]
                
Defined in [preprocessing/label.ts:40](https://github.com/JasonShin/kalimdorjs/blob/master/src/lib/preprocessing/label.ts#L40)
                


                        
**Parameters:**
                        
| Param | Type | Default | Description |
| ------ | ------ | ------ | ------ |
| X | any[] | [] | Input data to transform according to the fitted state

                        
**Returns:**
                        
any[]

