# preprocessing.add_dummy_feature





            
▸ **add_dummy_feature**(__namedParameters: *&#x60;object&#x60;*)
            
Augment dataset with an additional dummy feature.
This is useful for fitting an intercept term with implementations which cannot otherwise fit it directly.
            

                
### Usage
                    
```javascript
import { add_dummy_feature } from 'kalimdor/preprocessing';
const dummy = add_dummy_feature({ X: [[0, 1, 2], [1, 0, 3]] });
console.log(dummy); // returns: [ [ 1, 0, 1, 2 ], [ 1, 1, 0, 3 ] ]
```
        
Defined in [preprocessing/data.ts:51](https://github.com/JasonShin/kalimdorjs/blob/master/src/lib/preprocessing/data.ts#L51)

                
**Parameters:**
                
| Param | Type | Default | Description |
| ------ | ------ | ------ | ------ |
| options.X | number[][] | null | A matrix of data
| options.value | number | 1 | Value to use for the dummy feature.

                
**Returns:**
                
number[][]

