# preprocessing.normalize





            
▸ **normalize**(__namedParameters: *&#x60;object&#x60;*)
            
Data normalization is a process of scaling dataset based on Vector Space Model, and by default, it uses L2 normalization.
At a higher level, the chief difference between the L1 and the L2 terms is that the L2 term is proportional
to the square of the  β values, while the L1 norm is proportional the absolute value of the values in  β .
            

                
### Usage
                    
```javascript
import { normalize } from 'kalimdor/preprocessing';

const result = normalize({
  X: [
    [1, -1, 2],
    [2, 0, 0],
    [0, 1, -1],
  ],
});
console.log(result);
// [ [ 0.4082482904638631, -0.4082482904638631, 0.8164965809277261 ],
// [ 1, 0, 0 ],
// [ 0, 0.7071067811865475, -0.7071067811865475 ] ]
```
        
Defined in [preprocessing/data.ts:665](https://github.com/JasonShin/kalimdorjs/blob/master/src/lib/preprocessing/data.ts#L665)

                
**Parameters:**
                
| Param | Type | Default | Description |
| ------ | ------ | ------ | ------ |
| options.X | number[][] | null | The data to normalize
| options.norm | string | &quot;l2&quot; | The norm to use to normalize each non zero sample; can be either &#x27;l1&#x27; or &#x27;l2&#x27;

                
**Returns:**
                
number[][]

