"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var fs = require("fs-extra");
var lodash_1 = require("lodash");
var path = require("path");
var BaseProcesser_1 = require("./BaseProcesser");
var ConfigProcessor = /** @class */ (function (_super) {
    __extends(ConfigProcessor, _super);
    function ConfigProcessor() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.srcConfigPath = path.join(__dirname, '../config.js');
        _this.destConfigPath = path.join(__dirname, '../md_out/.vuepress/config.js');
        _this.srcPublicPath = path.join(__dirname, '../public');
        _this.destPublicPath = path.join(__dirname, '../md_out/.vuepress/public');
        _this.srcOverrideStylePath = path.join(__dirname, '../override.styl');
        _this.destOverrideStylePath = path.join(__dirname, '../md_out/.vuepress/override.styl');
        return _this;
    }
    /**
     * Runs the processor
     * @param {any} apiChildren
     */
    ConfigProcessor.prototype.run = function (_a) {
        var apiChildren = _a.apiChildren;
        if (lodash_1.isEmpty(apiChildren)) {
            throw Error('Cannot execute the processor because apiChildren is empty');
        }
        this.createDir();
        // 1. config
        fs.createReadStream(this.srcConfigPath).pipe(fs.createWriteStream(this.destConfigPath));
        // 2. public
        fs.copySync(this.srcPublicPath, this.destPublicPath);
        // 3. Style
        fs.createReadStream(this.srcOverrideStylePath).pipe(fs.createWriteStream(this.destOverrideStylePath));
    };
    /**
     * Create dir if not exist, it can be abstracted to a Utils file
     */
    ConfigProcessor.prototype.createDir = function () {
        // Create public dir if it doesn't exist
        if (!fs.existsSync(this.destPublicPath)) {
            fs.mkdirSync(this.destPublicPath);
        }
    };
    return ConfigProcessor;
}(BaseProcesser_1.BaseProcesser));
exports.ConfigProcessor = ConfigProcessor;
